// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 This object represents a file ready to be downloaded. The file can be downloaded via the link https://api.telegram.org/file/bot<token>/<file_path>. It is guaranteed that the link will be valid for at least 1 hour. When the link expires, a new one can be requested by calling getFile.
 Maximum file size to download is 20 MB

 SeeAlso Telegram Bot API Reference:
 [File](https://core.telegram.org/bots/api#file)
 */
public final class File: Codable {

    /// Custom keys for coding/decoding `File` struct
    enum CodingKeys: String, CodingKey {
        case fileId = "file_id"
        case fileUniqueId = "file_unique_id"
        case fileSize = "file_size"
        case filePath = "file_path"
    }

    /// Identifier for this file, which can be used to download or reuse the file
    public var fileId: String

    /// Unique identifier for this file, which is supposed to be the same over time and for different bots. Can't be used to download or reuse the file.
    public var fileUniqueId: String

    /// Optional. File size, if known
    public var fileSize: Int?

    /// Optional. File path. Use https://api.telegram.org/file/bot<token>/<file_path> to get the file.
    public var filePath: String?


    public init (fileId: String, fileUniqueId: String, fileSize: Int? = nil, filePath: String? = nil) {
        self.fileId = fileId
        self.fileUniqueId = fileUniqueId
        self.fileSize = fileSize
        self.filePath = filePath
    }
}
