// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 This object contains information about a poll.

 SeeAlso Telegram Bot API Reference:
 [Poll](https://core.telegram.org/bots/api#poll)
 */
public final class Poll: Codable {

    /// Custom keys for coding/decoding `Poll` struct
    enum CodingKeys: String, CodingKey {
        case id = "id"
        case question = "question"
        case options = "options"
        case totalVoterCount = "total_voter_count"
        case isClosed = "is_closed"
        case isAnonymous = "is_anonymous"
        case type = "type"
        case allowsMultipleAnswers = "allows_multiple_answers"
        case correctOptionId = "correct_option_id"
    }

    /// Unique poll identifier
    public var id: String

    /// Poll question, 1-255 characters
    public var question: String

    /// List of poll options
    public var options: [PollOption]

    /// Total number of users that voted in the poll
    public var totalVoterCount: Int

    /// True, if the poll is closed
    public var isClosed: Bool

    /// True, if the poll is anonymous
    public var isAnonymous: Bool

    /// Poll type, currently can be “regular” or “quiz”
    public var type: String

    /// True, if the poll allows multiple answers
    public var allowsMultipleAnswers: Bool

    /// Optional. 0-based identifier of the correct answer option. Available only for polls in the quiz mode, which are closed, or was sent (not forwarded) by the bot or to the private chat with the bot.
    public var correctOptionId: Int?


    public init (id: String, question: String, options: [PollOption], totalVoterCount: Int, isClosed: Bool, isAnonymous: Bool, type: String, allowsMultipleAnswers: Bool, correctOptionId: Int? = nil) {
        self.id = id
        self.question = question
        self.options = options
        self.totalVoterCount = totalVoterCount
        self.isClosed = isClosed
        self.isAnonymous = isAnonymous
        self.type = type
        self.allowsMultipleAnswers = allowsMultipleAnswers
        self.correctOptionId = correctOptionId
    }
}
